unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ToolWin, FileCtrl;

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    Memo1: TMemo;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FileListBox1: TFileListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FileListBox1Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const
 vntMask = '*.vnt';                        // 
 StartTag='ENCODING=QUOTED-PRINTABLE:=';   //  
 EndTag='END:VNOTE';                       //  

procedure TForm1.FormCreate(Sender: TObject);
begin
 FileListBox1.Mask:=vntMask;
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
begin //    memo
 Button1.Enabled:=true;
 Button2.Enabled:=true;
 Memo1.Lines.LoadFromFile(FileListbox1.Filename);
end;

procedure TForm1.DirectoryListBox1Change(Sender: TObject);
begin // ,    *.vnt
 Button1.Enabled:=false;
 Button2.Enabled:=false;
end;

function HexCharToInt (c:char):integer;
// 16-    
begin
 case c of
  '0'..'9': HexCharToInt:=Ord(c)-Ord('0');
  'A'..'F': HexCharToInt:=Ord(c)-Ord('A')+10;
  'a'..'f': HexCharToInt:=Ord(c)-Ord('a')+10;
  else HexCharToInt:=0;
 end;
end;

function HexStrToInt (s:string):integer;
//   XX,  X - 16- ,   
begin
 HexStrToInt:=HexCharToInt(s[1])*16 +HexCharToInt(s[2]);
end;

function Convert (Name:String):boolean; // 
var s,ch,txtname:String;
 f:TextFile;
 i1,i2:integer;
 outs:boolean;
begin
 Convert:=false;

 i1:=Pos (StartTag,Form1.Memo1.Text);
 i2:=Pos (EndTag,Form1.Memo1.Text);
 if (i1=0) or (i2=0) then begin
  ShowMessage ('         '+Name+'. ,        ');
  Exit;
 end;
 inc(i1,length(StartTag));
 s:=Copy (Form1.Memo1.Text, i1,i2-i1);

 i1:=1; i2:=Length (s); //   
 repeat // ,   
  if Ord(s[i1]) in [10,13] then begin
   Delete (s,i1,1);
   i2:=Length (s);
  end
  else inc (i1);
 until i1>i2;
 repeat //    -  ... ,  *.vnt  
  i1:=pos('==',s);
  if i1>0 then Delete (s,i1,1);
 until i1=0;
 //  *.txt
 txtname:=ChangeFileExt (Name, '.txt');
 if FileExists(txtname) then
  if MessageDlg('    ' +
    ExtractFileName(txtname) + '?',
    mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;
 AssignFile (f,txtname);
 {$I-}ReWrite (f);{$I+}
 if IoResult<>0 then begin
  ShowMessage ('   '+txtname+'  !     ');
  exit;
 end;
 //  
 outs:=false;
 repeat
  i1:=pos('=',s);
  if i1=0 then outs:=true
  else begin
   ch:=Copy(s,i1+1,2);
   i2 := HexStrToInt (ch);
   write (f,Chr(i2));
   Delete (s,i1,3);
  end;
 until outs;
 CloseFile (f);
 Convert:=true;
end;

procedure TForm1.Button1Click(Sender: TObject); // 
var r:boolean;
begin
 r:=Convert (FileListbox1.Filename);
 if r=true then
  ShowMessage ('  '+ChangeFileExt (FileListbox1.Filename, '.txt')+'   UTF-8');
end;

procedure TForm1.Button2Click(Sender: TObject); //   
var SearchRec: TSearchRec;
    Found : integer;
    FileName : String;
    r:boolean;
    all:integer;
begin
 all:=0;
 Found:=FindFirst(DirectoryListbox1.Directory+'\'+vntMask, faAnyFile, SearchRec);
 while Found=0 do begin
  FileName:=DirectoryListbox1.Directory+'\'+SearchRec.Name;
  Memo1.Lines.LoadFromFile(Filename);
  r:=Convert (FileName);
  if r=true then inc (all);
  Found:=FindNext(SearchRec);
 end;
 if all>0 then begin
  Str (all,FileName);
  ShowMessage ('    UTF-8: '+FileName);
 end;
end;

procedure TForm1.Button3Click(Sender: TObject); // 
begin
 Memo1.Lines.Clear;
 Memo1.Lines.Add (' VNT  TXT. (C) PerS (pers.narod.ru)'+#13+#10+
  ' ,       VNT,      ''''  ''  ''.'+
  '       UTF-8   TXT     .'+
  '     Windows.'
 );
end;

end.
